#include <fstream>
#include <iostream>   
#include <stdexcept>  
#include<cstdio>
#include<vector>
#include <eo>


#include<ga.h>
using namespace std;

vector<pair <int,int> > niz(100);
int volumen_ruksak;
unsigned broj;
typedef eoBit<double>  jedinka;



double dobrota(const jedinka & _niz)
{
  int ukupna_cijena=0;
  int ukupni_volumen=0;
  int pomocni;
  for (int i = 0; i < broj; i++) {
	  if (_niz[i]) {
		  ukupna_cijena+=niz[i].first;
		  ukupni_volumen+=niz[i].second;
		  }
	  }
  if (ukupni_volumen<=volumen_ruksak)
	  return (double)ukupna_cijena;
  else 
	  return 0;
}

void main_function(int argc, char **argv)
{
eoParser parser (argc,argv);

unsigned velicina_jedinke=broj;

eoValueParam<unsigned int> velicinapop(10,"velicina_populacije","Velicina populacije",'P');
parser.processParam(velicinapop,"Populacija");
unsigned velicina_populacije =velicinapop.value();

eoValueParam<unsigned int> velicinaturnir(3,"turnirska_selekcija","Velicina turnirske selekcije",'T');
parser.processParam(velicinaturnir,"Selekcija");
unsigned turnirska_selekcija=velicinaturnir.value();

eoValueParam<unsigned int> velicinaN(2,"velicina_N","Broj tocaka N krizanja",'N');
parser.processParam(velicinaN,"Krizanje");
unsigned Nkrizanje =velicinaN.value();

eoValueParam<double> vjerojatnost1kriz(0.8,"vjerojatnost_1_krizanja","Vjerojatnost 1 krizanja",'V');
parser.processParam(vjerojatnost1kriz,"Krizanje");
double vjer1krizanje =vjerojatnost1kriz.value();

eoValueParam<double> vjerojatnostUkriz(0.2,"vjerojatnost_U_krizanja","Vjerojatnost uniformnog krizanja",'U');
parser.processParam(vjerojatnostUkriz,"Krizanje");
double vjerUkrizanje=vjerojatnostUkriz.value();

eoValueParam<double> vjerojatnostNkriz(0.4,"vjerojatnost_N_krizanja","Vjerojatnost_N_krizanja",'K');
parser.processParam(vjerojatnostNkriz,"Krizanje");
double vjerNkrizanje =vjerojatnostNkriz.value();

eoValueParam<double> vjerojatnostBitmut(0.01,"vjerojatnost_bit_mutacije","Vjerojatnost jedonstavne mutacije",'M');
parser.processParam(vjerojatnostBitmut,"Mutacija");
double vjerBitMutacije =vjerojatnostBitmut.value();

eoValueParam<double> vjerojatnostpojBitmut(0.8,"vjerojatnost_pojave_bit_mutacije","Vjerojatnost pojave jedonstavne mutacije",'A');
parser.processParam(vjerojatnostpojBitmut,"Mutacija");
double vjerBmutacije =vjerojatnostpojBitmut.value();

eoValueParam<double> vjerojatnostpoj1mut(0.2,"vjerojatnost_pojave_1_mutacije","Vjerojatnost pojave mutacije tocno jednog bita",'B');
parser.processParam(vjerojatnostpoj1mut,"Mutacija");
double vjer1mutacije =vjerojatnostpoj1mut.value();

eoValueParam<double> vjerojatnostpojkriz(0.6,"vjerojatnost_pojave_krizanja","Vjerojatnost pojave opcenitog krizanja",'C');
parser.processParam(vjerojatnostpojkriz,"Krizanje");
double vjer_krizanje=vjerojatnostpojkriz.value();

eoValueParam<double> vjerojatnostpojmut(0.2,"vjerojatnost_mutacije","Vjerojatnost pojave opcenite muatacije",'D');
parser.processParam(vjerojatnostpojmut,"Mutacija");
double vjer_mutacije=vjerojatnostpojmut.value();

eoValueParam<unsigned int> velicinamaxgen(80,"max_generacija","Veliina max generacija",'E');
parser.processParam(velicinamaxgen,"Generacije");
unsigned max_generacija = velicinamaxgen.value();

eoValueParam<unsigned int> velicinamingen(10,"min_generacija","Veliina min generacija",'F');
parser.processParam(velicinamingen,"Generacije");
unsigned min_generacija = velicinamingen.value();

eoValueParam<unsigned int> velicinamirno(10,"mirnoca","Broj isti nepoboljanih generacija",'G');
parser.processParam(velicinamirno,"Generacije");
unsigned mirnoca = velicinamirno.value();

eoValueParam<double> velicinadobrota(1000,"dobrota","Maksimalna mogua dobrota",'H');
parser.processParam(velicinadobrota,"Generacije");
double naj_dobrota =velicinadobrota.value();

    if (parser.userNeedsHelp())
      {
        parser.printHelp(cout);
        exit(1);
      }
   

rng.reseed(time(NULL));
eoEvalFuncPtr<jedinka> eval1( dobrota );
eoEvalFuncCounter<jedinka> eval(eval1);
eoUniformGenerator<bool> generator;
eoInitFixedLength<jedinka> random(velicina_jedinke,generator);
eoPop<jedinka> populacija(velicina_populacije,random);
apply<jedinka> (eval,populacija);
populacija.sort();
cout<<populacija;

eoDetTournamentSelect<jedinka> turnir(turnirska_selekcija);
eoSelectPerc<jedinka> selekcija(turnir);
eoGenerationalReplacement<jedinka> zamjena;
eo1PtBitXover<jedinka> xover1;
eoUBitXover<jedinka> xoverU;
eoNPtsBitXover<jedinka> xover2(Nkrizanje);
eoPropCombinedQuadOp<jedinka> xover(xover1, vjer1krizanje);
xover.add(xoverU, vjerUkrizanje);
xover.add(xover2, vjerNkrizanje, true);
 
 
 eoBitMutation<jedinka>  mutationBit(vjerBitMutacije);
 eoDetBitFlip<jedinka> mutationOneBit; 
 eoPropCombinedMonOp<jedinka> mutation(mutationBit, vjerBmutacije);
 mutation.add(mutationOneBit, vjer1mutacije, true);
 
 eoSGATransform<jedinka> transform(xover, vjer_krizanje, mutation, vjer_mutacije);
 
 
 eoGenContinue<jedinka> genCont(max_generacija);
 eoSteadyFitContinue<jedinka> steadyCont(min_generacija, mirnoca);
 eoFitContinue<jedinka> fitCont(naj_dobrota);
 eoCombinedContinue<jedinka> continuator(genCont);
 continuator.add(steadyCont);
 continuator.add(fitCont);

 eoCheckPoint<jedinka> checkpoint(continuator);
 eoValueParam<unsigned> generationCounter(0, "Gen.");
 eoIncrementor<unsigned> increment(generationCounter.value());
 checkpoint.add(increment);
 eoBestFitnessStat<jedinka> bestStat;
 eoSecondMomentStats<jedinka> SecondStat;
 checkpoint.add(bestStat);
 checkpoint.add(SecondStat);
 eoStdoutMonitor monitor(false);
 checkpoint.add(monitor);
 monitor.add(generationCounter);
//monitor.add(eval);	
 monitor.add(bestStat);
 monitor.add(SecondStat);
 
 eoEasyEA<jedinka> gga(checkpoint, eval, selekcija, transform, zamjena);
 gga(populacija);
 populacija.sort();
 cout<<populacija;
populacija.clear();
}

int main(int argc, char **argv)
{
srand(time(NULL));

int i,vrijednost,volumen,j;
FILE *tok=fopen("podaci.txt","r");
while(1) {
	fscanf(tok,"%d %d",&broj,&volumen_ruksak);
	if (broj==0) break;
	for (i=0; i<broj; i++) {
		fscanf(tok ,"%d %d",&vrijednost,&volumen);
		niz[i].first=vrijednost;
		niz[i].second=volumen;
		}
    try
    {
        main_function(argc, argv);
    }
    catch(exception& e)
    {
        cout << "Exception: " << e.what() << '\n';
    }
	}
fclose(tok);
return 1;
}